searchData={"content_type":"text/markdown","items":[{"doc":"ExHashRing Application.\n\nStarts all the components of ExHashRing that must be running for the library to function\ncorrectly","ref":"ExHashRing.html","title":"ExHashRing","type":"module"},{"doc":"","ref":"ExHashRing.html#start/2","title":"ExHashRing.start/2","type":"function"},{"doc":"Configuration provides programmatic access into the various configuration settings that can be\nconfigured for ExHashRing.","ref":"ExHashRing.Configuration.html","title":"ExHashRing.Configuration","type":"module"},{"doc":"Clears any custom configuration for depth, this will cause it to revert to the default,\n1","ref":"ExHashRing.Configuration.html#clear_depth/0","title":"ExHashRing.Configuration.clear_depth/0","type":"function"},{"doc":"Clears any custom configuration for gc_delay, this will cause it to revert to the default,\n10000","ref":"ExHashRing.Configuration.html#clear_gc_delay/0","title":"ExHashRing.Configuration.clear_gc_delay/0","type":"function"},{"doc":"Clears any custom configuration for replicas, this will cause it to rever to the default,\n512","ref":"ExHashRing.Configuration.html#clear_replicas/0","title":"ExHashRing.Configuration.clear_replicas/0","type":"function"},{"doc":"Get the default operation timeout for ring operations. Unlike other configuration values,\nthis can only be configured at compile time.","ref":"ExHashRing.Configuration.html#get_default_operation_timeout/0","title":"ExHashRing.Configuration.get_default_operation_timeout/0","type":"macro"},{"doc":"Get the configured history depth.","ref":"ExHashRing.Configuration.html#get_depth/0","title":"ExHashRing.Configuration.get_depth/0","type":"function"},{"doc":"Get the configured gc delay.  Result is number of milliseconds to delay.","ref":"ExHashRing.Configuration.html#get_gc_delay/0","title":"ExHashRing.Configuration.get_gc_delay/0","type":"function"},{"doc":"Get the configured number of replicas.","ref":"ExHashRing.Configuration.html#get_replicas/0","title":"ExHashRing.Configuration.get_replicas/0","type":"function"},{"doc":"Puts the history depth.","ref":"ExHashRing.Configuration.html#put_depth/1","title":"ExHashRing.Configuration.put_depth/1","type":"function"},{"doc":"Puts the gc delay, delay is a positive number of milliseconds to wait before gc.","ref":"ExHashRing.Configuration.html#put_gc_delay/1","title":"ExHashRing.Configuration.put_gc_delay/1","type":"function"},{"doc":"Puts the number of replicas.","ref":"ExHashRing.Configuration.html#put_replicas/1","title":"ExHashRing.Configuration.put_replicas/1","type":"function"},{"doc":"Hash encapsulates the hashing logic for converting keys into ring locations.\n\nAny term that implements the String.Char protocol can be used as a key.","ref":"ExHashRing.Hash.html","title":"ExHashRing.Hash","type":"module"},{"doc":"Any term that can be coerced into a string (String.Chars.t()) is a hashable term.","ref":"ExHashRing.Hash.html#t:hashable/0","title":"ExHashRing.Hash.hashable/0","type":"type"},{"doc":"Calculate a hash of the hashable term.","ref":"ExHashRing.Hash.html#of/1","title":"ExHashRing.Hash.of/1","type":"function"},{"doc":"Hash for the term, this is used to locate Nodes in the Ring","ref":"ExHashRing.Hash.html#t:t/0","title":"ExHashRing.Hash.t/0","type":"type"},{"doc":"Provides an interface for querying information about Rings.\n\nEach Ring has some associated information that is available at all times to aid in performing\nclient-context queries into the underlying ETS table.non_neg_integer()","ref":"ExHashRing.Info.html","title":"ExHashRing.Info","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExHashRing.Info.html#child_spec/1","title":"ExHashRing.Info.child_spec/1","type":"function"},{"doc":"For any ring information can be looked up that will provide an entry containing specifics about\nthe table holding the ring data, the configured history depth, sizes for each generation in the\nhistory, the current generation, and any overrides that should be applied during lookup.","ref":"ExHashRing.Info.html#t:entry/0","title":"ExHashRing.Info.entry/0","type":"type"},{"doc":"Retrieves the info entry for the specified ring.","ref":"ExHashRing.Info.html#get/1","title":"ExHashRing.Info.get/1","type":"function"},{"doc":"","ref":"ExHashRing.Info.html#init/1","title":"ExHashRing.Info.init/1","type":"function"},{"doc":"Sets the info entry for the specified ring.","ref":"ExHashRing.Info.html#set/2","title":"ExHashRing.Info.set/2","type":"function"},{"doc":"","ref":"ExHashRing.Info.html#start_link/0","title":"ExHashRing.Info.start_link/0","type":"function"},{"doc":"","ref":"ExHashRing.Info.html#t:t/0","title":"ExHashRing.Info.t/0","type":"type"},{"doc":"Types and Functions for working with Ring Nodes and their Replicas","ref":"ExHashRing.Node.html","title":"ExHashRing.Node","type":"module"},{"doc":"Nodes can be defined by either using a bare name or using a fully specified node.  When using a\nbare name the definition will have to be converted into a fully specified node, see\n`normalize/2`.","ref":"ExHashRing.Node.html#t:definition/0","title":"ExHashRing.Node.definition/0","type":"type"},{"doc":"Expands a list of nodes into a list of virtual nodes.","ref":"ExHashRing.Node.html#expand/1","title":"ExHashRing.Node.expand/1","type":"function"},{"doc":"","ref":"ExHashRing.Node.html#expand/2","title":"ExHashRing.Node.expand/2","type":"function"},{"doc":"Nodes are uniquely identified in the ring by their name.","ref":"ExHashRing.Node.html#t:name/0","title":"ExHashRing.Node.name/0","type":"type"},{"doc":"Converts definitions into fully specified nodes.\n\nA single definition or a list of defintions can be normalized by this function.","ref":"ExHashRing.Node.html#normalize/2","title":"ExHashRing.Node.normalize/2","type":"function"},{"doc":"Replicas is a count of how many times a Node should be placed into a Ring.\n\nNegative replica counts will result in an ArgumentError when expanded","ref":"ExHashRing.Node.html#t:replicas/0","title":"ExHashRing.Node.replicas/0","type":"type"},{"doc":"Nodes are properly specified as a tuple of their name and their number of replicas","ref":"ExHashRing.Node.html#t:t/0","title":"ExHashRing.Node.t/0","type":"type"},{"doc":"Nodes are expanded into multiple virtual nodes.","ref":"ExHashRing.Node.html#t:virtual/0","title":"ExHashRing.Node.virtual/0","type":"type"},{"doc":"A pure Elixir consistent hash ring.\n\nRing data is stored in an ETS table owned by the ExHashRing.Ring GenServer.  This module\nprovides functions for managing and querying a consistent hash ring quickly and efficiently.","ref":"ExHashRing.Ring.html","title":"ExHashRing.Ring","type":"module"},{"doc":"Adds a node to the existing set of nodes in the ring.","ref":"ExHashRing.Ring.html#add_node/4","title":"ExHashRing.Ring.add_node/4","type":"function"},{"doc":"Adds multiple nodes to the existing set of nodes in the ring.","ref":"ExHashRing.Ring.html#add_nodes/3","title":"ExHashRing.Ring.add_nodes/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExHashRing.Ring.html#child_spec/1","title":"ExHashRing.Ring.child_spec/1","type":"function"},{"doc":"Rings maintain a history, the history is limited to depth number of generations to retain.","ref":"ExHashRing.Ring.html#t:depth/0","title":"ExHashRing.Ring.depth/0","type":"type"},{"doc":"","ref":"ExHashRing.Ring.html#do_find_stable_nodes/5","title":"ExHashRing.Ring.do_find_stable_nodes/5","type":"function"},{"doc":"","ref":"ExHashRing.Ring.html#find_historical_node/3","title":"ExHashRing.Ring.find_historical_node/3","type":"function"},{"doc":"Finds the specified number of nodes responsible for the given key in the specified ring's\nhistory, going back `back` number of generations.","ref":"ExHashRing.Ring.html#find_historical_nodes/4","title":"ExHashRing.Ring.find_historical_nodes/4","type":"function"},{"doc":"Finds the node responsible for the given key in the specified ring.","ref":"ExHashRing.Ring.html#find_node/2","title":"ExHashRing.Ring.find_node/2","type":"function"},{"doc":"Finds the specified number of nodes responsible for the given key in the specified ring's\ncurrent generation.","ref":"ExHashRing.Ring.html#find_nodes/3","title":"ExHashRing.Ring.find_nodes/3","type":"function"},{"doc":"Finds the specificed number of nodes responsible for the given key by looking at each generation\nin the ring's configured depth.  See `find_stable_nodes/4` for more information.","ref":"ExHashRing.Ring.html#find_stable_nodes/3","title":"ExHashRing.Ring.find_stable_nodes/3","type":"function"},{"doc":"Finds the specified number of nodes responsible for the given key in the specified ring's\ncurrent generation and in the history of the ring.  This means that this function returns up to\n`back` * `num`; where `num` = number of nodes requested, and `back` = the number of generations\nto consider.","ref":"ExHashRing.Ring.html#find_stable_nodes/4","title":"ExHashRing.Ring.find_stable_nodes/4","type":"function"},{"doc":"Forces a garbage collection of a specific generation, all generations pending garbage collection\nif `:all_pending` is specified. If a specific generation is specified, the it must be pending or\nelse `{:error, :not_pending}` is returned.","ref":"ExHashRing.Ring.html#force_gc/3","title":"ExHashRing.Ring.force_gc/3","type":"function"},{"doc":"Generations act as a grouping mechanism to associate many records together as one logical and\natomic group.","ref":"ExHashRing.Ring.html#t:generation/0","title":"ExHashRing.Ring.generation/0","type":"type"},{"doc":"Get the current ring generation","ref":"ExHashRing.Ring.html#get_generation/1","title":"ExHashRing.Ring.get_generation/1","type":"function"},{"doc":"Retrieves the current set of node names from the ring.","ref":"ExHashRing.Ring.html#get_nodes/2","title":"ExHashRing.Ring.get_nodes/2","type":"function"},{"doc":"Retrieves the current set of nodes as tuples of {name, replicas} from the ring.","ref":"ExHashRing.Ring.html#get_nodes_with_replicas/2","title":"ExHashRing.Ring.get_nodes_with_replicas/2","type":"function"},{"doc":"Retrieves the current set of overrides from the ring.","ref":"ExHashRing.Ring.html#get_overrides/2","title":"ExHashRing.Ring.get_overrides/2","type":"function"},{"doc":"Retrieves a list of pending gc generations.","ref":"ExHashRing.Ring.html#get_pending_gcs/2","title":"ExHashRing.Ring.get_pending_gcs/2","type":"function"},{"doc":"","ref":"ExHashRing.Ring.html#init/1","title":"ExHashRing.Ring.init/1","type":"function"},{"doc":"Any hashable key can be looked up in the ring to find the nodes that own that key.","ref":"ExHashRing.Ring.html#t:key/0","title":"ExHashRing.Ring.key/0","type":"type"},{"doc":"Rings are named with a unique atom.","ref":"ExHashRing.Ring.html#t:name/0","title":"ExHashRing.Ring.name/0","type":"type"},{"doc":"Union type that represents all valid options","ref":"ExHashRing.Ring.html#t:option/0","title":"ExHashRing.Ring.option/0","type":"type"},{"doc":"Option that controls the number of generations to retain for lookup.\n\nDefaults to 1","ref":"ExHashRing.Ring.html#t:option_depth/0","title":"ExHashRing.Ring.option_depth/0","type":"type"},{"doc":"Option that controls the name to register this process under, Rings that are registered can use\ntheir name in place of their pid.\n\nDefaults behavior is to not register the Ring process.","ref":"ExHashRing.Ring.html#t:option_name/0","title":"ExHashRing.Ring.option_name/0","type":"type"},{"doc":"Option that controls the initial nodes for the Ring.\n\nDefaults to []","ref":"ExHashRing.Ring.html#t:option_nodes/0","title":"ExHashRing.Ring.option_nodes/0","type":"type"},{"doc":"Option that controls the initial overrides for the Ring.\n\nDefaults to %{}","ref":"ExHashRing.Ring.html#t:option_overrides/0","title":"ExHashRing.Ring.option_overrides/0","type":"type"},{"doc":"Option that controls the number of replicas to use for nodes that do not define replicas.\n\nDefaults to 512","ref":"ExHashRing.Ring.html#t:option_replicas/0","title":"ExHashRing.Ring.option_replicas/0","type":"type"},{"doc":"List of options that can be provided when starting a Ring, see the `t:option/0` type and its\nassociated types for more information.","ref":"ExHashRing.Ring.html#t:options/0","title":"ExHashRing.Ring.options/0","type":"type"},{"doc":"Overrides allow the Ring to always resolve a given key to a set list of nodes.","ref":"ExHashRing.Ring.html#t:overrides/0","title":"ExHashRing.Ring.overrides/0","type":"type"},{"doc":"Removes a node from the ring by its name.","ref":"ExHashRing.Ring.html#remove_node/3","title":"ExHashRing.Ring.remove_node/3","type":"function"},{"doc":"Atomically remove multiple nodes from the ring by name","ref":"ExHashRing.Ring.html#remove_nodes/3","title":"ExHashRing.Ring.remove_nodes/3","type":"function"},{"doc":"Several functions accept either a name for a named Ring or a pid for an anonymous Ring","ref":"ExHashRing.Ring.html#t:ring/0","title":"ExHashRing.Ring.ring/0","type":"type"},{"doc":"Replaces the nodes in the ring with a new set of nodes.","ref":"ExHashRing.Ring.html#set_nodes/3","title":"ExHashRing.Ring.set_nodes/3","type":"function"},{"doc":"Replaces the overrides in the ring with new overrides.","ref":"ExHashRing.Ring.html#set_overrides/3","title":"ExHashRing.Ring.set_overrides/3","type":"function"},{"doc":"Ring size is a memoized count of the number of logical nodes in a ring","ref":"ExHashRing.Ring.html#t:size/0","title":"ExHashRing.Ring.size/0","type":"type"},{"doc":"Start and link a Ring with the given name.\n\nRing supports various options see `t:options/0` for more information.","ref":"ExHashRing.Ring.html#start_link/1","title":"ExHashRing.Ring.start_link/1","type":"function"},{"doc":"Stops the GenServer holding the Ring.","ref":"ExHashRing.Ring.html#stop/1","title":"ExHashRing.Ring.stop/1","type":"function"},{"doc":"","ref":"ExHashRing.Ring.html#t:t/0","title":"ExHashRing.Ring.t/0","type":"type"},{"doc":"Utility functions used throughout ExHashRing","ref":"ExHashRing.Utils.html","title":"ExHashRing.Utils","type":"module"},{"doc":"Take up to maximum items from a list.\n\nThis function returns the items in reverse order and with a count of how many items were found.","ref":"ExHashRing.Utils.html#take_max/2","title":"ExHashRing.Utils.take_max/2","type":"function"},{"doc":"# ExHashRing\n\n[![CI](https://github.com/discord/ex_hash_ring/workflows/CI/badge.svg)](https://github.com/discord/ex_hash_ring/actions)\n[![Hex.pm Version](http://img.shields.io/hexpm/v/ex_hash_ring.svg?style=flat)](https://hex.pm/packages/ex_hash_ring)\n[![Hex.pm License](http://img.shields.io/hexpm/l/ex_hash_ring.svg?style=flat)](https://hex.pm/packages/ex_hash_ring)\n[![HexDocs](https://img.shields.io/badge/HexDocs-Yes-blue)](https://hexdocs.pm/ex_hash_ring)\n\nA pure Elixir consistent hash ring implemention based on the excellent [C hash-ring lib](https://github.com/chrismoos/hash-ring) by [Chris Moos](https://github.com/chrismoos).\n\nExHashRing is a production ready library actively maintained and in use at [Discord](https://discord.com).\n\nExHashRing provides the following features.\n\n- Lookup optimized ring storage. A ring is stored in an [ETS table](https://erlang.org/doc/man/ets.html) which provides excellent lookup performance.\n- Key overrides that allow the client to pin a key to a member.\n- Configurable replica count for virtual nodes.\n- Configurable history that allows for stable lookups over time.","ref":"readme.html","title":"ExHashRing","type":"extras"},{"doc":"Add it to `mix.exs`.\n\n```elixir\ndefp deps do\n  [{:ex_hash_ring, \"~> 6.0\"}]\nend\n```","ref":"readme.html#installation","title":"Installation - ExHashRing","type":"extras"},{"doc":"Version 6.0.0 introduces a number of breaking changes.  Refer to the [Upgrade Guide](/pages/upgrade.md) for instructions.","ref":"readme.html#upgrading-to-6-0-0","title":"Upgrading to 6.0.0 - ExHashRing","type":"extras"},{"doc":"Each Ring is managed by a GenServer, here's an example of starting an empty Ring.\n\n```elixir\niex(1)> alias ExHashRing.Ring\nExHashRing.Ring\niex(2)> {:ok, ring} = Ring.start_link()\n{:ok, #PID<0.166.0>}\n```\n\nWe can add a single node with `add_node/2`\n\n```elixir\niex(3)> Ring.add_node(ring, \"a\")\n{:ok, [{\"a\", 512}]}\n```\n\nThe `512` above is the number of replicas for this node.  Since we did not specify a custom number of replicas, it was added with the default for this Ring, which itself defaults to `512`.  We can control the number of default replicas when we start_link the Ring and we can control the number of replicas on a per-node basis.\n\nWe can add another node with a custom replica count with `add_node/3`\n\n```elixir\niex(4)> Ring.add_node(ring, \"b\", 100)\n{:ok, [{\"b\", 100}, {\"a\", 512}]}\n```\n\nNow that we have some nodes we can use our Ring to map keys to nodes with the `find_node/2` function.\n\n```elixir\niex(5)> Ring.find_node(ring, \"key1\")\n{:ok, \"a\"}\niex(6)> Ring.find_node(ring, \"key37\")\n{:ok, \"b\"}\n```","ref":"readme.html#quickstart","title":"Quickstart - ExHashRing","type":"extras"},{"doc":"The Quickstart above just scratches the surface of the functionality that ExHashRing provides.  For more details see the [HexDocs](https://hexdocs.pm/ex_hash_ring)","ref":"readme.html#documentation","title":"Documentation - ExHashRing","type":"extras"},{"doc":"ExHashRing exposes some configuration options under the `:ex_hash_ring` key.\n\n| Key         | Description                                                                              | Default |\n|-------------|------------------------------------------------------------------------------------------|---------|\n| `:depth`    | Default history depth for new rings                                                      | 1       |\n| `:gc_delay` | The amount of time, in milliseconds, to wait before garbage collecting stale generations | 10_000  |\n| `:replicas` | Default replicas setting for new rings                                                   | 512     |","ref":"readme.html#configuration","title":"Configuration - ExHashRing","type":"extras"},{"doc":"Hash Ring is released under [the MIT License](LICENSE). Check [LICENSE](LICENSE) file for more information.","ref":"readme.html#license","title":"License - ExHashRing","type":"extras"},{"doc":"# Upgrade Guild","ref":"upgrade.html","title":"Upgrade Guild","type":"extras"},{"doc":"6.0.0 introduces a number of breaking changes.","ref":"upgrade.html#upgrading-to-6-0-0","title":"Upgrading to 6.0.0 - Upgrade Guild","type":"extras"},{"doc":"One of the largest changes is that 6.0.0 removes the in-memory HashRing.  The library is now more opinionated about how the ring should be stored and queried.  Rings are owned by a GenServer, which has ownership over the ETS table used to store the Ring.\n\nEven though the Ring is owned by a GenServer, the lookups into the Ring are done in the client context by reading from the ETS table.","ref":"upgrade.html#removal-of-the-in-memory-hashring","title":"Removal of the In-Memory HashRing - Upgrade Guild","type":"extras"},{"doc":"With the In-Memory and ETS versions of the Ring unified into a single model, some Module renaming was done to simplify the library.\n\n| Pre-6.0.0                      | 6.0.0            | Change                                                         |\n|--------------------------------|------------------|----------------------------------------------------------------|\n| ExHashRing                     | ExHashRing       | No Change                                                      |\n| ExHashRing.HashRing            | ExHashRing.Ring  | The datastructure is removed in favor of the GenServer version |\n| ExHashRing.HashRing.Utils      | ExHashRing.Utils | No Change                                                      |\n| ExHashRing.HashRing.ETS        | ExHashRing.Ring  | Module renamed to Ring, interface has changed                  |\n| ExHashRing.HashRing.ETS.Config | ExHashRing.Info  | Module renamed, entry structure changed          |","ref":"upgrade.html#renaming-of-modules","title":"Renaming of Modules - Upgrade Guild","type":"extras"},{"doc":"Rings now have the ability to store a history of ring snapshots.  The history is configurable and the default configuration sets the `depth` to 1.  History support allows the caller to handle situations where they want to find out the assignment of a key to a node in a previous configuration of the ring.\n\nThese new functions allow the caller to lookup a key in previous configurations of the Ring.\n\n- `find_historical_node/3`\n- `find_historical_nodes/4`\n- `find_stable_nodes/3,4`\n\n`find_historical_node` and `find_historical_nodes` both accept an argument called `back` which is the number of generations to look back in the history.\n\n`find_stable_nodes` will combine the results of looking back over all or some subset of the history and combines the results together.\n\nAny time the Ring changes a new Generation is written out into the History.  To prevent generating intermediate generations, new batch APIs have been introduced for altering the Ring.\n\n- `add_nodes/2`\n- `remove_nodes/2`\n\nThese are similar to `add_node/2` and `remove_node/2` but can add or remove multiple nodes while only creating one new generation.\n\nChanging Overrides does not generate a new generation and no history is retained for overrides.","ref":"upgrade.html#history-support","title":"History Support - Upgrade Guild","type":"extras"},{"doc":"In existing code any place where `ExHashRing.HashRing` was being used should be changed to `ExHashRing.Ring`.  This is no longer a datastructure but a Process and the caller is responsible for supervision like any other Elixir Process.\n\nIn existing code any plat where `ExHashRing.HashRing.ETS` was being used can use the `ExHashRing.Ring` module as a mostly drop in replacement.\n\n#### `start_link/2` -> `start_link/1`\n\nPre-6.0.0 every ring had to be named and then optionally the process could be registered.  This could result in some very confusing issues when using unregistered rings becuase the ring names are required to be unique.  Consider the following code and keep in mind that during an iex session it's obvious what is happening, but with supervisors restarting processes the unintuitive behavior can be far away from the start_link calls.\n\n```elixir\niex(1)> {:ok, first} = ExHashRing.HashRing.ETS.start_link(:example, nodes: [\"a\", \"b\"])\n{:ok, #PID<0.165.0>}\niex(2)> ExHashRing.HashRing.ETS.find_node(:example, \"key1\")\n{:ok, \"a\"}\niex(3)> {:ok, second} = ExHashRing.HashRing.ETS.start_link(:example, nodes: [\"c\", \"d\"])\n{:ok, #PID<0.168.0>}\niex(4)> ExHashRing.HashRing.ETS.find_node(:example, \"key1\")\n{:ok, \"c\"}\niex(5)> Process.alive?(first)\ntrue\niex(6)> Process.alive?(second)\ntrue\niex(7)> ExHashRing.HashRing.ETS.add_node(first, \"f\")\n{:ok, [{\"f\", 512}, {\"a\", 512}, {\"b\", 512}]}\niex(8)> ExHashRing.HashRing.ETS.add_node(second, \"g\")\n{:ok, [{\"g\", 512}, {\"c\", 512}, {\"d\", 512}]}\niex(9)> ExHashRing.HashRing.ETS.add_node(:example, \"h\")\n** (exit) exited in: GenServer.call(:example, {:add_node, \"h\", nil}, 5000)\n    ** (EXIT) no process: the process is not alive or there's no process currently associated with the given name, possibly because its application isn't started\n    (elixir) lib/gen_server.ex:914: GenServer.call/3\n```\n\nThe conflict occurs because the ring's name is used as the global configuration key.  Since the processes don't attempt to register the conflict is never detected and two processes can happily coexists with whoever writes last win semantics.\n\nPre-6.0.0 when the caller was required to pass the ring's name atom vs when they could provide the ring's pid was fairly inconsistent.\n\n| function                  | Ring `named: false` | Ring `named: true` |\n|---------------------------|---------------------|--------------------|\n| add_node/2,3              | pid                 | pid OR name        |\n| find_node/2               | name                | name               |\n| find_nodes/3              | name                | name               |\n| force_gc/1,2              | pid                 | pid OR name        |\n| get_overrides/1           | pid                 | pid OR name        |\n| get_nodes/1               | pid                 | pid OR name        |\n| get_nodes_with_replicas/1 | pid                 | pid OR name        |\n| get_ring_gen/1            | name                | name               |\n| remove_node/2             | pid                 | pid OR name        |\n| set_nodes/2               | pid                 | pid OR name        |\n| set_overrides/2           | pid                 | pid OR name        |\n| stop/1                    | pid                 | pid OR name        |\n\n6.0.0 allows the caller to create either named rings (via the `name` option) or unnamed rings.  Both named and unnamed rings can be operated on via their pid.  Named rings can also be operated on by their name.  The equivalent table in 6.0.0 would look like this.\n\n| function                  | Unnamed Ring | Named Ring  |\n|---------------------------|--------------|-------------|\n| any function              | pid          | pid OR name |\n\n#### Naming and Registering\n\nPre-6.0.0 every ring was required to have a name and the `:named` option was a boolean that would control whether or not the ring's process registered under that name as well.  This meant that `start_link/2` has a single required argument, the name, and an optional argument, a Keyword of options.\n\n6.0.0 no longer requires that every ring be named, unnamed rings can be operated on entirely through their pid alone.  Naming a ring now requires that the process also register under that name to prevent ring collisions.  To create a named ring use the `:name` option which accepts an atom to name the ring and its process after.\n#### New Options for `start_link/2`\n\n`start_link/2` has gained a new option, `:depth` which controls how many generations of history the ring should retain.\n\n#### Renamed Options for `start_link/2`\n\nThe option `:default_num_replicas` was renamed to `:replicas`.\n\nThe option `:named` was renamed to `:name` and accepts the name directly instead of a boolean, see the Naming and Registering section for more details.\n#### Renamed `get_ring_gen/1`\n\nSince a Generation is now a more important concepts in the library this function was renamed from `get_ring_gen/1` to `get_generation/1`.","ref":"upgrade.html#ring-interface","title":"Ring Interface - Upgrade Guild","type":"extras"},{"doc":"`ExHashRing.HashRing.ETS.Config` was renamed to `ExHashRing.Info` and serves a similar purpose.  The interface is largely the same, but the entry tuple that can be saved and read to has been changed.\n\nThe module was renamed from `Config` to `Info` because it holds look-aside information similar to `Process.info`.  This is also to deconflict it with the concept of Application Configuration.\n\n#### Pre-6.0.0\n\nPre-6.0.0 each entry in the Config was structured as a tuple containing the following information\n\n```elixir\n{\n    ets_table_reference :: reference(),\n    ring_generation :: integer(),\n    num_nodes :: integer()\n}\n```\n\nor\n\n```elixir\n{\n    ets_table_reference :: reference()\n    ring_generation :: integer(),\n    num_nodes :: integer(),\n    override_map :: %{atom() => [binary()]}\n}\n```\n\n#### 6.0.0\n\nIn 6.0.0 more ring information is required to support the history functionality and to unify the two older representations into a single coherent representation.\n\nThe entries in the table are always structured as follows.\n\n```elixir\n{\n    ets_table_reference :: reference(),\n    depth :: Ring.depth() :: pos_integer(),\n    sizes :: [Ring.size()] :: [non_neg_integer()],\n    generation :: integer(),\n    overrides :: %{Ring.key() :: Hash.hashable() :: String.Chars.t() => [Node.name() :: binary()]}\n}\n```\n\nNote that the sizes is a list up to `depth` entries long that holds the number of nodes in each generation of the history starting with the current generation and then continuing with each subsequent generation.\n\n#### Upgrading\n\nThe `ExHashRing.HashRing.ETS.Config` is largely an internal implementation detail and in the vast majority of cases nothing needs to be done to upgrade.  Code that was manually reading or writing configuration should be updated to read the new structure and write out the new structure.","ref":"upgrade.html#ring-info","title":"Ring Info - Upgrade Guild","type":"extras"},{"doc":"The `take_max/2` utility function has been left in this module but the `hash/1` and `gen_items/1,2` functions have been relocated.\n\n`ExHashRing.Utils.hash/1` has been replaced by the `ExHashRing.Hash.of/1` function.\n\n`ExHashRing.Utils.gen_items/1,2` has been replaced by the `ExHashRing.Node.expand/1,2` functions.\n\nBoth of these replacements work largely in the same way as the previous versions and were moved out of Utils into more appropriate modules.","ref":"upgrade.html#exhashring-utils","title":"ExHashRing.Utils - Upgrade Guild","type":"extras"},{"doc":"Prior to version 6.0.0 ExHashRing only had a single configuration value that could be set, `:hash_ring` `:ring_gen_gc_delay`\n\nThis keyspace is non-conventional since it disagrees with the OTP Application name.  6.0.0 corrects this and stores configuration under the `:ex_hash_ring` key.\n\nRefer to the following table for more migration details\n\n| Pre-6.0.0            | 6.0.0       | Description                                                                                                               |\n|----------------------|-------------|---------------------------------------------------------------------------------------------------------------------------|\n| `:ring_gen_gc_delay` | `:gc_delay` | The amount of time, in milliseconds, to wait before garbage collecting stale generations, defaults to 10_000 (10 seconds) |\n| N / A                | `:depth`    | Default history depth for new rings, defaults to 1                                                                        |\n| N / A                | `:replicas` | Default replicas setting for new rings, defaults to 512                                                                   |","ref":"upgrade.html#application-configuration","title":"Application Configuration - Upgrade Guild","type":"extras"}],"producer":{"name":"ex_doc","version":"0.37.3"},"proglang":"elixir"}